Avoid spurious rebuilds of the dynamic lookups Makefile.
[exim.git] / src / scripts / lookups-Makefile
index cd0a51b340769efdd766456810090aa4cd2d0625..e7aeaa08aaa0f818936dfabbc4d28c1a635f17e1 100755 (executable)
@@ -28,8 +28,8 @@ then
 fi
 
 input=lookups/Makefile.predynamic
-target=lookups/Makefile
-defs_source=Makefile
+target=lookups/Makefile.postdynamic
+defs_source=Makefile-t
 tag_marker='MAGIC-TAG-MODS-OBJ-RULES-GO-HERE'
 
 tab='  '
@@ -44,20 +44,19 @@ export LC_ALL
 # nb: do not permit leading whitespace for this, as CFLAGS_DYNAMIC is exported
 # to the lookups subdir via a line with leading whitespace which otherwise
 # matches
-if grep -q "^CFLAGS_DYNAMIC[ $tab]*=" "$defs_source"
+if grep -q "^CFLAGS_DYNAMIC[ $tab?:]*=" "$defs_source"
 then
   # we have a definition, we're good to go
+  echo >&2 ">>> Creating lookups/Makefile for building dynamic modules"
   enable_dynamic=yes
 else
-  echo >&2 "Missing CFLAGS_DYNAMIC inhibits building dynamic module lookup"
+  echo >&2 ">>> Creating lookups/Makefile without dynamic module support"
   enable_dynamic=''
   # We always do something now, since there should always be a lookup,
   # and now we need to run in order to put the OBJ=$(OBJ)+ rules in.  So we
   # continue on.
 fi
 
-tmp="$target.t"
-
 # For the want_ checks, we need to let the user override values from the make
 # command-line, not just check the Makefile.
 
@@ -84,7 +83,7 @@ OBJ=""
 
 emit_module_rule() {
   local lookup_name="$1"
-  local mod_name
+  local mod_name pkgconf
   if [ "${lookup_name%:*}" = "$lookup_name" ]
   then
     mod_name=$(echo $lookup_name | tr A-Z a-z)
@@ -96,21 +95,29 @@ emit_module_rule() {
   if want_dynamic "$lookup_name"
   then
     if [ -z "$enable_dynamic" ]; then
-      echo >&2 "Inhibited dynamic modules prevents building dynamic $lookup_name"
+      echo >&2 "Missing CFLAGS_DYNAMIC prevents building dynamic $lookup_name"
       exit 1
     fi
     MODS="${MODS} ${mod_name}.so"
-    grep "^LOOKUP_${lookup_name}_" "$defs_source"
-    echo "LOOKUP_${mod_name}_INCLUDE = \$(LOOKUP_${lookup_name}_INCLUDE)"
-    echo "LOOKUP_${mod_name}_LIBS = \$(LOOKUP_${lookup_name}_LIBS)"
+    pkgconf=$(grep "^LOOKUP_${lookup_name}_PC" "$defs_source")
+    if [ $? -eq 0 ]; then
+      pkgconf=$(echo $pkgconf | sed 's/^.*= *//')
+      echo "LOOKUP_${mod_name}_INCLUDE = $(pkg-config --cflags $pkgconf)"
+      echo "LOOKUP_${mod_name}_LIBS = $(pkg-config --libs $pkgconf)"
+    else
+      grep "^LOOKUP_${lookup_name}_" "$defs_source"
+      echo "LOOKUP_${mod_name}_INCLUDE = \$(LOOKUP_${lookup_name}_INCLUDE)"
+      echo "LOOKUP_${mod_name}_LIBS = \$(LOOKUP_${lookup_name}_LIBS)"
+    fi
   elif want_at_all "$lookup_name"
   then
     OBJ="${OBJ} ${mod_name}.o"
   fi
 }
 
+rm -f "$target"
 exec 5>&1
-exec > "$tmp"
+exec > "$target"
 
 sed -n "1,/$tag_marker/p" < "$input"
 
@@ -138,7 +145,7 @@ echo "OBJ = $OBJ"
 sed -n "/$tag_marker/,\$p" < "$input"
 
 exec >&5
-mv "$tmp" "$target"
 
+# Configure-Makefile will move $target into place
 
 # vim: set ft=sh sw=2 :